#!/bin/bash

ipvalid() {
  # Set up local variables
  local ip=${1:-1.2.3.4}
  local IFS=.; local -a a=($ip)
  # Start with a regex format test
  [[ $ip =~ ^[0-9]+(\.[0-9]+){3}$ ]] || return 1
  # Test values of quads
  for quad in {0..3}; do
    [[ "${a[$quad]}" -gt 255 ]] && return 1
  done
  return 0
}



while getopts a:s:g:d: option
do
	case "${option}"
	in
	a) IPADDRESS=${OPTARG};;
	s) SUBNET=${OPTARG};;
	g) GATEWAY=${OPTARG};;
	d) DNSSERVER=${OPTARG};;
	esac
done

#IFACENAME=$(ip -o link show | sed -rn '/^[0-9]+: en/{s/.: ([^:]*):.*/\1/p}')
IFACENAME="eth0"

echo "Interface = ${IFACENAME}"
echo "ip address = ${IPADDRESS}"
echo "subnet = ${SUBNET}"
echo "gateway = ${GATEWAY}"
echo "Dns server= ${DNSSERVER}"
echo "interface = ${IFACENAME}"

if [[ $IPADDRESS == '0.0.0.0' ]]; then
  echo "setting to dymanic"
  IP=$(/sbin/ip addr show eth0)
  echo $IP
  #ip addr show eth0
  if [[ $IP == *"DOWN"* ]]; then
    echo "ethernet interface down"
  else
    ifconfig $IFACENAME 0.0.0.0 0.0.0.0 && dhclient
  fi
  echo "set to dynamic"
elif ipvalid "$IPADDRESS" && ipvalid "$SUBNET" && ipvalid "$GATEWAY" && ipvalid "$DNSSERVER"; then
	echo "setting up static ip"
#  ifconfig $IFACENAME down
#  killall dhclient && ifconfig $IFACENAME $IPADDRESS netmask $SUBNET up
ifconfig $IFACENAME $IPADDRESS netmask $SUBNET up

sudo route del default
sudo route add default gw $GATEWAY $IFACENAME


#  ip link set $IFACENAME down


  echo "nameserver $DNSSERVER" > /etc/resolv.conf
  echo "static ip address set up"
else
  echo "I shouldn't be here...network shutdown!"
  ifconfig $IFACENAME down
fi

ifconfig $IFACENAME up

echo "change i.p address complete"
